// Phase Frequency Detector
//
// Version 1a, 1 June 04
//
// Olaf Zinke
//
// Downloaded from The Designer's Guide Community (www.designers-guide.org).
// Post any questions on www.designers-guide.org/Forum.
// Taken from "The Designer's Guide to Verilog-AMS" by Kundert & Zinke.
// Appendix A, Listing 5.

`timescale 10ps / 1ps

module sdm1(clk, rst, v_out);
input clk, rst;
//input [28:0] k_in;
output  v_out;
reg  v_out;
reg [28:0] a1;
wire [28:0] s1,q1;
wire  c1;
//assign s1 = 29'b00100110011010011010110101000 + a1;
assign s1 = a1;
assign c1 = {s1[28]};
assign q1={s1[27:0] };
always@(posedge clk or posedge rst) 
begin
	if(rst) a1<=29'h0;
	else a1<=q1;
end
always@(posedge clk or posedge rst)
begin
	if(rst)
	begin
		v_out<=1'b01;
	end
else
	begin
		v_out<=c1;
	end
end
endmodule
